# Exercice 3
# Écrire une fonction qui retourne le nombre d’occurrence d’un caractère dans une chaîne.


# O(n), n la taille de la chaine
# car on itère simplement dessus et la boucle utile une comparaison entre deux chaines
# charactère de taille 1 => complexité O(1).

def occurrence(chaine: str, char: str) -> int:
    compteur = 0
    for element in chaine:
        if char == element:
            compteur += 1
    return compteur


def occurrence_fonctionnelle(chaine: str, char: str) -> int:
    return sum(map(lambda e: char == e, chaine))


def occurrence_bad(chaine: str, char: str) -> int:
    compteur = 0
    for i in range(len(chaine)):  # BAD, pas besoin d'index ici
        if char == chaine[i]:
            compteur += 1
    return compteur


# Écrire une fonction qui affiche le nombre d’occurrence de chaque voyelle (en minuscule et majuscule, accentuées ou non) dans une chaîne de caractères (indice: réutilisez la fonction précédente).


# Complexité en O(nk) avec n la taille de la chaine, k le nombre de voyelle dans l'alphabet.
# En supposant que chercher dans un dictionnaire est en O(1)
def affiche_voyelle(chaine: str) -> None:
    voyelles = {"a": "aâAÂàÀ", "e": "eEéèÉÈÊê" }
    for voy_base in voyelles:
        compteur = 0
        for char in voyelles[voy]: # On récupère la chaine associé a voy, O(1)
            compteur += occurrence(chaine, char)
        print(f"{voy_base}:{compteur}") # f-string, voir la documentation

def affiche_voyelle_fonctionnelle(chaine: str) -> None:
    voyelles = {"a": "aâAÂàÀ", "e": "eEéèÉÈÊê" }
    for voy_base in voyelles:
        compteur = sum(map(lambda e:occurrence(chaine, e), voyelles[voy]))
        print(f"{voy_base}:{compteur}") 
        

# Exercice 4:

# Écrire une fonction qui gbrouille le mot dans un texte de façon ce que le texte demeure lisible.
# Par exemple le texte suivant: gDbeout ! les dmanés de la trere ! Dobeut ! les fotçars de la fiam ! La raosin tonne en son crtaère , C’ est l’éruptoin de la fin . C’est lisible, non?
# 
# Vous gbrouillerez les mots en échangéant la position de 2 lettres choisies au hasard parmi les lettres du centre du mot (c’est-à-dire ni la première ni la dernière).

import string
from random import randint

def gbrouille_mot(chaine: str) -> str:
    # chaine est un mot sans séparateur
    if len(chaine) <= 3:
        return chaine
    centre_mot = chaine[1:-1]

    if len(set(centre_mot)) == 1:
        return chaine

    #diff = False
    #for a in centre_mot[1:]:
    #    if a != centre_mot[0]:
    #        diff = True
    #        break
    #if not diff:
    #    return chaine

    
    while True:
        i = random.randint(0, len(centre_mot)) 
        j = random.randint(0, len(centre_mot)) 
        if centre_mot[i] == centre_mot[j]:
            continue

        nouveau_mot = centre_mot[:i-1] + centre_mot[j] + centre_mot[i+1:j-1] + centre_mot[i] + centre_mot[j+1:]
        return nouveau_mot

        # alternative
        L = list(centre_mot)
        L[i], L[j] = L[j], L[i]
        nouveau_mot = "".join(L)
    


def gbrouille(chaine: str) -> str:
    separateur = string.punctuation + string.whitespace
    mot = ""
    resultat = ""
    for lettre in chaine:
        if lettre in separateur:
            resultat += gbrouille_mot(mot)
            resultat += lettre
            mot = ""
        else:
            mot += lettre
    return resultat
